Package org.apache.commons.math3.stat.descriptive.rank

# Class Min

java.lang.Object
org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
org.apache.commons.math3.stat.descriptive.rank.Min

All Implemented Interfaces:
  `Serializable`, `StorelessUnivariateStatistic`, `UnivariateStatistic`, `MathArrays.Function`

public class Min extends AbstractStorelessUnivariateStatistic implements Serializable
Returns the minimum of the available values.

- The result is `NaN` iff all values are `NaN` (i.e. `NaN` values have no impact on the value of the statistic).
- If any of the values equals `Double.NEGATIVE_INFINITY`, the result is `Double.NEGATIVE_INFINITY.`

Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`Min()`
Create a Min instance
`Min(Min original)`
Copy constructor, creates a new `Min` identical to the `original`

## Method Summary

Modifier and Type
Method
Description
`void`
`clear()`
Clears the internal state of the Statistic
`Min`
`copy()`
Returns a copy of the statistic with the same internal state.
`static void`
`copy(Min source, Min dest)`
Copies source to dest.
`double`
`evaluate(double[] values, int begin, int length)`
Returns the minimum of the entries in the specified portion of the input array, or `Double.NaN` if the designated subarray is empty.
`long`
`getN()`
Returns the number of values that have been added.
`double`
`getResult()`
Returns the current value of the Statistic.
`void`
`increment(double d)`
Updates the internal state of the statistic to reflect the addition of the new value.

### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic

`equals, evaluate, hashCode, incrementAll, incrementAll`

### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic

`evaluate, getData, getDataRef, setData, setData, test, test, test, test`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Min

public Min()
Create a Min instance

### Min

public Min(Min original) throws NullArgumentException
Copy constructor, creates a new `Min` identical to the `original`

Parameters:
  `original` - the `Min` instance to copy
Throws:
  `NullArgumentException` - if original is null

## Method Details

### increment

public void increment(double d)
Updates the internal state of the statistic to reflect the addition of the new value.

Specified by:
  `increment` in interface `StorelessUnivariateStatistic`
Specified by:
  `increment` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `d` - the new value.

### clear

public void clear()
Clears the internal state of the Statistic

Specified by:
  `clear` in interface `StorelessUnivariateStatistic`
Specified by:
  `clear` in class `AbstractStorelessUnivariateStatistic`

### getResult

public double getResult()
Returns the current value of the Statistic.

Specified by:
  `getResult` in interface `StorelessUnivariateStatistic`
Specified by:
  `getResult` in class `AbstractStorelessUnivariateStatistic`
Returns:
  value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

### getN

public long getN()
Returns the number of values that have been added.

Specified by:
  `getN` in interface `StorelessUnivariateStatistic`
Returns:
  the number of values.

### evaluate

public double evaluate(double[] values, int begin, int length) throws MathIllegalArgumentException
Returns the minimum of the entries in the specified portion of the input array, or `Double.NaN` if the designated subarray is empty.

Throws `MathIllegalArgumentException` if the array is null or the array index parameters are not valid.

- The result is `NaN` iff all values are `NaN` (i.e. `NaN` values have no impact on the value of the statistic).
- If any of the values equals `Double.NEGATIVE_INFINITY`, the result is `Double.NEGATIVE_INFINITY.`

Specified by:
  `evaluate` in interface `MathArrays.Function`
Specified by:
  `evaluate` in interface `UnivariateStatistic`
Overrides:
  `evaluate` in class `AbstractStorelessUnivariateStatistic`
Parameters:
  `values` - the input array
  `begin` - index of the first array element to include
  `length` - the number of elements to include
Returns:
  the minimum of the values or Double.NaN if length = 0
Throws:
  `MathIllegalArgumentException` - if the array is null or the array index parameters are not valid
See Also:
  - `UnivariateStatistic.evaluate(double[], int, int)`

### copy

public Min copy()
Returns a copy of the statistic with the same internal state.

Specified by:
  `copy` in interface `StorelessUnivariateStatistic`
Specified by:
  `copy` in interface `UnivariateStatistic`
Specified by:
  `copy` in class `AbstractStorelessUnivariateStatistic`
Returns:
  a copy of the statistic

### copy

public static void copy(Min source, Min dest) throws NullArgumentException
Copies source to dest.

Neither source nor dest can be null.

Parameters:
  `source` - Min to copy
  `dest` - Min to copy to
Throws:
  `NullArgumentException` - if either source or dest is null